diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/distributed-simulator-impl.h ns-3.33/src/mpi/model/distributed-simulator-impl.h
--- ns-3.32/src/mpi/model/distributed-simulator-impl.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/distributed-simulator-impl.h	2021-01-09 10:19:22.000000000 -0800
@@ -17,6 +17,12 @@
  *
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ *  Declaration of classes  ns3::LbtsMessage and ns3::DistributedSimulatorImpl.
+ */
+
 #ifndef NS3_DISTRIBUTED_SIMULATOR_IMPL_H
 #define NS3_DISTRIBUTED_SIMULATOR_IMPL_H
 
@@ -85,11 +91,11 @@
   bool IsFinished ();
 
 private:
-  uint32_t m_txCount;
-  uint32_t m_rxCount;
-  uint32_t m_myId;
-  Time     m_smallestTime;
-  bool     m_isFinished;
+  uint32_t m_txCount;         /**< Count of transmitted messages. */ 
+  uint32_t m_rxCount;         /**< Count of received messages. */ 
+  uint32_t m_myId;            /**< System Id of the rank sending this LBTS. */
+  Time     m_smallestTime;    /**< Earliest next event timestamp. */
+  bool     m_isFinished;      /**< \c true when this rank has no more events. */
 };
 
 /**
@@ -101,9 +107,15 @@
 class DistributedSimulatorImpl : public SimulatorImpl
 {
 public:
+  /**
+   *  Register this type.
+   *  \return The object TypeId.
+   */
   static TypeId GetTypeId (void);
 
+  /** Default constructor. */
   DistributedSimulatorImpl ();
+  /** Destructor. */
   ~DistributedSimulatorImpl ();
 
   // virtual from SimulatorImpl
@@ -122,41 +134,101 @@
   virtual Time Now (void) const;
   virtual Time GetDelayLeft (const EventId &id) const;
   virtual Time GetMaximumSimulationTime (void) const;
-  virtual void SetMaximumLookAhead (const Time lookAhead);
   virtual void SetScheduler (ObjectFactory schedulerFactory);
   virtual uint32_t GetSystemId (void) const;
   virtual uint32_t GetContext (void) const;
   virtual uint64_t GetEventCount (void) const;
 
+  /**
+   * Add additional bound to lookahead constraints.
+   *
+   * This may be used if there are additional constraints on lookahead
+   * in addition to the minimum inter rank latency time.  For example
+   * when running ns-3 in a co-simulation setting the other simulators
+   * may have tighter lookahead constraints.
+   * 
+   * The method may be invoked more than once, the minimum time will
+   * be used to constrain lookahead.
+   *
+   * \param [in] lookAhead The maximum lookahead; must be > 0.
+   */
+  virtual void BoundLookAhead (const Time lookAhead);
+  
 private:
+  // Inherited from Object
   virtual void DoDispose (void);
+
+  /**
+   * Calculate lookahead constraint based on network latency.
+   *
+   * The smallest cross-rank PointToPoint channel delay imposes
+   * a constraint on the conservative PDES time window.  The
+   * user may impose additional constraints on lookahead
+   * using the ConstrainLookAhead() method.
+   */
   void CalculateLookAhead (void);
+  /**
+   * Check if this rank is finished.  It's finished when there are
+   * no more events or stop has been requested.
+   *
+   * \returns \c true when this rank is finished.
+   */
   bool IsLocalFinished (void) const;
 
+  /** Process the next event. */
   void ProcessOneEvent (void);
+  /**
+   * Get the timestep of the next event.
+   *
+   * If there are no more events the timestep is infinity.
+   *
+   * \return The next event timestep.
+   */
   uint64_t NextTs (void) const;
+  /**
+   * Get the time of the next event, as returned by NextTs().
+   *
+   * \return The next event time stamp.
+   */
   Time Next (void) const;
+
+  /** Container type for the events to run at Simulator::Destroy(). */
   typedef std::list<EventId> DestroyEvents;
 
+  /** The container of events to run at Destroy() */
   DestroyEvents m_destroyEvents;
+  /** Flag calling for the end of the simulation. */
   bool m_stop;
-  bool m_globalFinished;     // Are all parallel instances completed.
+  /** Are all parallel instances completed. */
+  bool m_globalFinished;     
+  /** The event priority queue. */
   Ptr<Scheduler> m_events;
+  
+  /** Next event unique id. */
   uint32_t m_uid;
+  /** Unique id of the current event. */
   uint32_t m_currentUid;
+  /** Timestamp of the current event. */
   uint64_t m_currentTs;
+  /** Execution context of the current event. */
   uint32_t m_currentContext;
   /** The event count. */
   uint64_t m_eventCount;
-  // number of events that have been inserted but not yet scheduled,
-  // not counting the "destroy" events; this is used for validation
+  /**
+   * Number of events that have been inserted but not yet scheduled,
+   * not counting the "destroy" events; this is used for validation.
+   */
   int m_unscheduledEvents;
 
-  LbtsMessage* m_pLBTS;       // Allocated once we know how many systems
-  uint32_t     m_myId;        // MPI Rank
-  uint32_t     m_systemCount; // MPI Size
-  Time         m_grantedTime; // Last LBTS
-  static Time  m_lookAhead;   // Lookahead value
+  /**
+   * Container for Lbts messages, one per rank.
+   * Allocated once we know how many systems there are.
+   */
+  LbtsMessage* m_pLBTS;
+  uint32_t     m_myId;        /**< MPI rank. */
+  uint32_t     m_systemCount; /**< MPI communicator size. */
+  Time         m_grantedTime; /**< End of current window. */
+  static Time  m_lookAhead;   /**< Current window size. */
 
 };
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/granted-time-window-mpi-interface.cc ns-3.33/src/mpi/model/granted-time-window-mpi-interface.cc
--- ns-3.32/src/mpi/model/granted-time-window-mpi-interface.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/granted-time-window-mpi-interface.cc	2021-01-09 10:19:22.000000000 -0800
@@ -14,7 +14,12 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: George Riley <riley@ece.gatech.edu>
- *
+ */
+
+/**
+ * \file
+ * \ingroup mpi
+ * Implementation of classes ns3::SentBuffer and ns3::GrantedTimeWindowMpiInterface.
  */
 
 // This object contains static methods that provide an easy interface
@@ -42,6 +47,8 @@
 
 NS_LOG_COMPONENT_DEFINE ("GrantedTimeWindowMpiInterface");
 
+NS_OBJECT_ENSURE_REGISTERED (GrantedTimeWindowMpiInterface);
+
 SentBuffer::SentBuffer ()
 {
   m_buffer = 0;
@@ -71,16 +78,18 @@
   return &m_request;
 }
 
-uint32_t              GrantedTimeWindowMpiInterface::m_sid = 0;
-uint32_t              GrantedTimeWindowMpiInterface::m_size = 1;
-bool                  GrantedTimeWindowMpiInterface::m_initialized = false;
-bool                  GrantedTimeWindowMpiInterface::m_enabled = false;
-uint32_t              GrantedTimeWindowMpiInterface::m_rxCount = 0;
-uint32_t              GrantedTimeWindowMpiInterface::m_txCount = 0;
-std::list<SentBuffer> GrantedTimeWindowMpiInterface::m_pendingTx;
-
-MPI_Request* GrantedTimeWindowMpiInterface::m_requests;
-char**       GrantedTimeWindowMpiInterface::m_pRxBuffers;
+uint32_t              GrantedTimeWindowMpiInterface::g_sid = 0;
+uint32_t              GrantedTimeWindowMpiInterface::g_size = 1;
+bool                  GrantedTimeWindowMpiInterface::g_enabled = false;
+bool                  GrantedTimeWindowMpiInterface::g_mpiInitCalled = false;
+uint32_t              GrantedTimeWindowMpiInterface::g_rxCount = 0;
+uint32_t              GrantedTimeWindowMpiInterface::g_txCount = 0;
+std::list<SentBuffer> GrantedTimeWindowMpiInterface::g_pendingTx;
+
+MPI_Request* GrantedTimeWindowMpiInterface::g_requests;
+char**       GrantedTimeWindowMpiInterface::g_pRxBuffers;
+MPI_Comm     GrantedTimeWindowMpiInterface::g_communicator = MPI_COMM_WORLD;
+bool         GrantedTimeWindowMpiInterface::g_freeCommunicator = false;;
 
 TypeId 
 GrantedTimeWindowMpiInterface::GetTypeId (void)
@@ -99,79 +108,100 @@
 
   for (uint32_t i = 0; i < GetSize (); ++i)
     {
-      delete [] m_pRxBuffers[i];
+      delete [] g_pRxBuffers[i];
     }
-  delete [] m_pRxBuffers;
-  delete [] m_requests;
+  delete [] g_pRxBuffers;
+  delete [] g_requests;
 
-  m_pendingTx.clear ();
+  g_pendingTx.clear ();
 }
 
 uint32_t
 GrantedTimeWindowMpiInterface::GetRxCount ()
 {
-  return m_rxCount;
+  NS_ASSERT (g_enabled);
+  return g_rxCount;
 }
 
 uint32_t
 GrantedTimeWindowMpiInterface::GetTxCount ()
 {
-  return m_txCount;
+  NS_ASSERT (g_enabled);
+  return g_txCount;
 }
 
 uint32_t
 GrantedTimeWindowMpiInterface::GetSystemId ()
 {
-  if (!m_initialized)
-    {
-      Simulator::GetImplementation ();
-      m_initialized = true;
-    }
-  return m_sid;
+  NS_ASSERT (g_enabled);
+  return g_sid;
 }
 
 uint32_t
 GrantedTimeWindowMpiInterface::GetSize ()
 {
-  if (!m_initialized)
-    {
-      Simulator::GetImplementation ();
-      m_initialized = true;
-    }
-  return m_size;
+  NS_ASSERT (g_enabled);
+  return g_size;
 }
 
 bool
 GrantedTimeWindowMpiInterface::IsEnabled ()
 {
-  if (!m_initialized)
-    {
-      Simulator::GetImplementation ();
-      m_initialized = true;
-    }
-  return m_enabled;
+  return g_enabled;
+}
+
+MPI_Comm 
+GrantedTimeWindowMpiInterface::GetCommunicator() 
+{
+  NS_ASSERT (g_enabled);
+  return g_communicator;
 }
 
 void
 GrantedTimeWindowMpiInterface::Enable (int* pargc, char*** pargv)
 {
-  NS_LOG_FUNCTION (this << pargc << pargv); 
+  NS_LOG_FUNCTION (this << pargc << pargv);
+
+  NS_ASSERT (g_enabled == false);
 
   // Initialize the MPI interface
   MPI_Init (pargc, pargv);
-  MPI_Barrier (MPI_COMM_WORLD);
-  MPI_Comm_rank (MPI_COMM_WORLD, reinterpret_cast <int *> (&m_sid));
-  MPI_Comm_size (MPI_COMM_WORLD, reinterpret_cast <int *> (&m_size));
-  m_enabled = true;
-  m_initialized = true;
+  Enable (MPI_COMM_WORLD);
+  g_mpiInitCalled = true;
+  g_enabled = true;
+}
+
+void
+GrantedTimeWindowMpiInterface::Enable (MPI_Comm communicator)
+{
+  NS_LOG_FUNCTION (this);
+
+  NS_ASSERT (g_enabled == false);
+
+  // Standard MPI practice is to duplicate the communicator for
+  // library to use.  Library communicates in isolated communication
+  // context.
+  MPI_Comm_dup (communicator, &g_communicator);
+  g_freeCommunicator = true;
+  
+  MPI_Barrier (g_communicator);
+  
+  int mpiSystemId;
+  int mpiSize;
+  MPI_Comm_rank (g_communicator, &mpiSystemId);
+  MPI_Comm_size (g_communicator, &mpiSize);
+  g_sid = mpiSystemId;
+  g_size = mpiSize;
+  
+  g_enabled = true;
   // Post a non-blocking receive for all peers
-  m_pRxBuffers = new char*[m_size];
-  m_requests = new MPI_Request[m_size];
+  g_pRxBuffers = new char*[g_size];
+  g_requests = new MPI_Request[g_size];
   for (uint32_t i = 0; i < GetSize (); ++i)
     {
-      m_pRxBuffers[i] = new char[MAX_MPI_MSG_SIZE];
-      MPI_Irecv (m_pRxBuffers[i], MAX_MPI_MSG_SIZE, MPI_CHAR, MPI_ANY_SOURCE, 0,
-                 MPI_COMM_WORLD, &m_requests[i]);
+      g_pRxBuffers[i] = new char[MAX_MPI_MSG_SIZE];
+      MPI_Irecv (g_pRxBuffers[i], MAX_MPI_MSG_SIZE, MPI_CHAR, MPI_ANY_SOURCE, 0,
+                 g_communicator, &g_requests[i]);
     }
 }
 
@@ -181,8 +211,8 @@
   NS_LOG_FUNCTION (this << p << rxTime.GetTimeStep () << node << dev);
 
   SentBuffer sendBuf;
-  m_pendingTx.push_back (sendBuf);
-  std::list<SentBuffer>::reverse_iterator i = m_pendingTx.rbegin (); // Points to the last element
+  g_pendingTx.push_back (sendBuf);
+  std::list<SentBuffer>::reverse_iterator i = g_pendingTx.rbegin (); // Points to the last element
 
   uint32_t serializedSize = p->GetSerializedSize ();
   uint8_t* buffer =  new uint8_t[serializedSize + 16];
@@ -202,8 +232,8 @@
   uint32_t nodeSysId = destNode->GetSystemId ();
 
   MPI_Isend (reinterpret_cast<void *> (i->GetBuffer ()), serializedSize + 16, MPI_CHAR, nodeSysId,
-             0, MPI_COMM_WORLD, (i->GetRequest ()));
-  m_txCount++;
+             0, g_communicator, (i->GetRequest ()));
+  g_txCount++;
 }
 
 void
@@ -218,17 +248,17 @@
       int index = 0;
       MPI_Status status;
 
-      MPI_Testany (MpiInterface::GetSize (), m_requests, &index, &flag, &status);
+      MPI_Testany (MpiInterface::GetSize (), g_requests, &index, &flag, &status);
       if (!flag)
         {
           break;        // No more messages
         }
       int count;
       MPI_Get_count (&status, MPI_CHAR, &count);
-      m_rxCount++; // Count this receive
+      g_rxCount++; // Count this receive
 
       // Get the meta data first
-      uint64_t* pTime = reinterpret_cast<uint64_t *> (m_pRxBuffers[index]);
+      uint64_t* pTime = reinterpret_cast<uint64_t *> (g_pRxBuffers[index]);
       uint64_t time = *pTime++;
       uint32_t* pData = reinterpret_cast<uint32_t *> (pTime);
       uint32_t node = *pData++;
@@ -261,8 +291,8 @@
                                       &MpiReceiver::Receive, pMpiRec, p);
 
       // Re-queue the next read
-      MPI_Irecv (m_pRxBuffers[index], MAX_MPI_MSG_SIZE, MPI_CHAR, MPI_ANY_SOURCE, 0,
-                 MPI_COMM_WORLD, &m_requests[index]);
+      MPI_Irecv (g_pRxBuffers[index], MAX_MPI_MSG_SIZE, MPI_CHAR, MPI_ANY_SOURCE, 0,
+                 g_communicator, &g_requests[index]);
     }
 }
 
@@ -271,8 +301,8 @@
 {
   NS_LOG_FUNCTION_NOARGS ();
 
-  std::list<SentBuffer>::iterator i = m_pendingTx.begin ();
-  while (i != m_pendingTx.end ())
+  std::list<SentBuffer>::iterator i = g_pendingTx.begin ();
+  while (i != g_pendingTx.end ())
     {
       MPI_Status status;
       int flag = 0;
@@ -281,7 +311,7 @@
       i++;                                    // Advance to next
       if (flag)
         { // This message is complete
-          m_pendingTx.erase (current);
+          g_pendingTx.erase (current);
         }
     }
 }
@@ -291,18 +321,29 @@
 {
   NS_LOG_FUNCTION_NOARGS ();
 
-  int flag = 0;
-  MPI_Initialized (&flag);
-  if (flag)
+  if (g_freeCommunicator)
     {
-      MPI_Finalize ();
-      m_enabled = false;
-      m_initialized = false;
+      MPI_Comm_free (&g_communicator);
+      g_freeCommunicator = false;
     }
-  else
+
+  // ns-3 should MPI finalize only if ns-3 was used to initialize
+  if (g_mpiInitCalled)
     {
-      NS_FATAL_ERROR ("Cannot disable MPI environment without Initializing it first");
+      int flag = 0;
+      MPI_Initialized (&flag);
+      if (flag)
+        {
+          MPI_Finalize ();
+        }
+      else
+        {
+          NS_FATAL_ERROR ("Cannot disable MPI environment without Initializing it first");
+        }
+      g_mpiInitCalled = false;
     }
+
+  g_enabled = false;
 }
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/granted-time-window-mpi-interface.h ns-3.33/src/mpi/model/granted-time-window-mpi-interface.h
--- ns-3.32/src/mpi/model/granted-time-window-mpi-interface.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/granted-time-window-mpi-interface.h	2021-01-09 10:19:22.000000000 -0800
@@ -14,7 +14,12 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: George Riley <riley@ece.gatech.edu>
- *
+ */
+
+/**
+ * \file
+ * \ingroup mpi
+ * Declaration of classes ns3::SentBuffer and ns3::GrantedTimeWindowMpiInterface.
  */
 
 // This object contains static methods that provide an easy interface
@@ -69,11 +74,12 @@
   MPI_Request* GetRequest ();
 
 private:
-  uint8_t* m_buffer;
-  MPI_Request m_request;
+  uint8_t* m_buffer;      /**< The buffer. */
+  MPI_Request m_request;  /**< The MPI request handle. */
 };
 
 class Packet;
+class DistributedSimulatorImpl;
 
 /**
  * \ingroup mpi
@@ -87,46 +93,33 @@
 class GrantedTimeWindowMpiInterface : public ParallelCommunicationInterface, Object
 {
 public:
-  static TypeId GetTypeId (void);
-
   /**
-   * Delete all buffers
+   *  Register this type.
+   *  \return The object TypeId.
    */
+  static TypeId GetTypeId (void);
+
+  // Inherited
   virtual void Destroy ();
-  /**
-   * \return MPI rank
-   */
   virtual uint32_t GetSystemId ();
-  /**
-   * \return MPI size (number of systems)
-   */
   virtual uint32_t GetSize ();
-  /**
-   * \return true if using MPI
-   */
   virtual bool IsEnabled ();
-  /**
-   * \param pargc number of command line arguments
-   * \param pargv command line arguments
-   *
-   * Sets up MPI interface
-   */
   virtual void Enable (int* pargc, char*** pargv);
-  /**
-   * Terminates the MPI environment by calling MPI_Finalize
-   * This function must be called after Destroy ()
-   * It also resets m_initialized, m_enabled
-   */
-  virtual void Disable ();
-  /**
-   * \param p packet to send
-   * \param rxTime received time at destination node
-   * \param node destination node
-   * \param dev destination device
-   *
-   * Serialize and send a packet to the specified node and net device
-   */
+  virtual void Enable (MPI_Comm communicator);
+  virtual void Disable();
   virtual void SendPacket (Ptr<Packet> p, const Time &rxTime, uint32_t node, uint32_t dev);
+  virtual MPI_Comm GetCommunicator();
+
+private:
+
+  /*
+   * The granted time window implementation is a collaboration of several
+   * classes.  Methods that should be invoked only by the
+   * collaborators are private to restrict use.
+   * It is not intended for state to be shared.
+   */
+  friend ns3::DistributedSimulatorImpl;
+  
   /**
    * Check for received messages complete
    */
@@ -143,27 +136,41 @@
    * \return transmitted count in packets
    */
   static uint32_t GetTxCount ();
+  
+  /** System ID (rank) for this task. */
+  static uint32_t g_sid;
+  /** Size of the MPI COM_WORLD group. */
+  static uint32_t g_size;
 
-private:
-  static uint32_t m_sid;
-  static uint32_t m_size;
+  /** Total packets received. */
+  static uint32_t g_rxCount;
+
+  /** Total packets sent. */
+  static uint32_t g_txCount;
+
+  /** Has this interface been enabled. */
+  static bool     g_enabled;
+
+  /**
+   * Has MPI Init been called by this interface.
+   * Alternatively user supplies a communicator.
+   */
+  static bool     g_mpiInitCalled;
 
-  // Total packets received
-  static uint32_t m_rxCount;
+  /** Pending non-blocking receives. */
+  static MPI_Request* g_requests;
 
-  // Total packets sent
-  static uint32_t m_txCount;
-  static bool     m_initialized;
-  static bool     m_enabled;
+  /** Data buffers for non-blocking reads. */
+  static char**   g_pRxBuffers;
 
-  // Pending non-blocking receives
-  static MPI_Request* m_requests;
+  /** List of pending non-blocking sends. */
+  static std::list<SentBuffer> g_pendingTx;
 
-  // Data buffers for non-blocking reads
-  static char**   m_pRxBuffers;
+  /** MPI communicator being used for ns-3 tasks. */
+  static MPI_Comm g_communicator;
 
-  // List of pending non-blocking sends
-  static std::list<SentBuffer> m_pendingTx;
+  /** Did ns-3 create the communicator?  Have to free it. */
+  static bool g_freeCommunicator;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/mpi-interface.cc ns-3.33/src/mpi/model/mpi-interface.cc
--- ns-3.32/src/mpi/model/mpi-interface.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/mpi-interface.cc	2021-01-09 10:19:22.000000000 -0800
@@ -16,7 +16,12 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: Steven Smith <smith84@llnl.gov>
- *
+ */
+
+/**
+ * \file
+ * \ingroup mpi
+ * Implementation of class ns3::MpiInterface.
  */
 
 #include "mpi-interface.h"
@@ -73,7 +78,7 @@
 }
 
 void
-MpiInterface::Enable (int* pargc, char*** pargv)
+MpiInterface::SetParallelSimulatorImpl (void)
 {
   StringValue simulationTypeValue;
   bool useDefault = true;
@@ -104,17 +109,38 @@
                          StringValue ("ns3::DistributedSimulatorImpl"));
       NS_LOG_WARN ("SimulatorImplementationType was set to non-parallel simulator; setting type to ns3::DistributedSimulatorImp");
     }
+}
+
+void
+MpiInterface::Enable (int* pargc, char*** pargv)
+{
+
+  SetParallelSimulatorImpl ();
 
   g_parallelCommunicationInterface->Enable (pargc, pargv);
 }
 
 void
+MpiInterface::Enable (MPI_Comm communicator)
+{
+  SetParallelSimulatorImpl ();
+  g_parallelCommunicationInterface->Enable (communicator);
+}
+
+void
 MpiInterface::SendPacket (Ptr<Packet> p, const Time& rxTime, uint32_t node, uint32_t dev)
 {
   NS_ASSERT (g_parallelCommunicationInterface);
   g_parallelCommunicationInterface->SendPacket (p, rxTime, node, dev);
 }
 
+MPI_Comm 
+MpiInterface::GetCommunicator()
+{
+  NS_ASSERT (g_parallelCommunicationInterface);
+  return g_parallelCommunicationInterface->GetCommunicator ();
+}
+
 
 void
 MpiInterface::Disable ()
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/mpi-interface.h ns-3.33/src/mpi/model/mpi-interface.h
--- ns-3.32/src/mpi/model/mpi-interface.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/mpi-interface.h	2021-01-09 10:19:22.000000000 -0800
@@ -16,7 +16,12 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: Steven Smith <smith84@llnl.gov>
- *
+ */
+
+/**
+ * \file
+ * \ingroup mpi
+ * Declaration of class ns3::MpiInterface.
  */
 
 #ifndef NS3_MPI_INTERFACE_H
@@ -25,6 +30,8 @@
 #include <ns3/nstime.h>
 #include <ns3/packet.h>
 
+#include "mpi.h"
+
 namespace ns3 {
 /**
  * \defgroup mpi MPI Distributed Simulation
@@ -51,41 +58,78 @@
 {
 public:
   /**
-   * Deletes storage used by the parallel environment.
+   * \brief Deletes storage used by the parallel environment.
    */
   static void Destroy ();
   /**
-   * \return system identification
+   * \brief Get the id number of this rank.
    *
    * When running a sequential simulation this will return a systemID of 0.
+   *
+   * \return system identification
    */
   static uint32_t GetSystemId ();
   /**
-   * \return number of parallel tasks
+   * \brief Get the number of ranks used by ns-3.
+   *
+   * Returns the size (number of MPI ranks) of the communicator used by
+   * ns-3.  When running a sequential simulation this will return a
+   * size of 1.
    *
-   * When running a sequential simulation this will return a size of 1.
+   * \return number of parallel tasks
    */
   static uint32_t GetSize ();
   /**
+   * \brief Returns enabled state of parallel environment.
+   *
    * \return true if parallel communication is enabled
    */
   static bool IsEnabled ();
   /**
+   * \brief Setup the parallel communication interface.
+   *
+   * There are two ways to setup the communications interface.  This
+   * Enable method is the easiest method and should be used in most
+   * situations.
+   *
+   * Disable() must be invoked at end of an ns-3 application to 
+   * properly cleanup the parallel communication interface.
+   *
+   * This method will call MPI_Init and configure ns-3 to use the
+   * MPI_COMM_WORLD communicator.
+   *
+   * For more complex situations, such as embedding ns-3 with other
+   * MPI simulators or libraries, the Enable(MPI_Comm communcicator)
+   * may be used if MPI is initialized externally or if ns-3 needs to
+   * be run unique communicator.  For example if there are two
+   * parallel simulators and the goal is to run each simulator on a
+   * different set of ranks.
+   *
+   * \note The `SimulatorImplementationType attribute in
+   * ns3::GlobalValues must be set before calling Enable()
+   *
    * \param pargc number of command line arguments
    * \param pargv command line arguments
+   */
+  static void Enable (int* pargc, char*** pargv);
+  /**
+   * \brief Setup the parallel communication interface using the specified communicator.
    *
-   * \brief Sets up parallel communication interface.
+   * See @ref Enable (int* pargc, char*** pargv) for additional information.
    *
-   * SimulatorImplementationType attribute in ns3::GlobalValues must be set before
-   * Enable is invoked.
+   * \param communicator MPI Communicator that should be used by ns-3
    */
-  static void Enable (int* pargc, char*** pargv);
+  static void Enable (MPI_Comm communicator);
   /**
-   * Terminates the parallel environment.
-   * This function must be called after Destroy ()
+   * \brief Clean up the ns-3 parallel communications interface.
+   *
+   * MPI_Finalize will be called only if Enable (int* pargc, char***
+   * pargv) was called.
    */
   static void Disable ();
   /**
+   * \brief Send a packet to a remote node.
+   *
    * \param p packet to send
    * \param rxTime received time at destination node
    * \param node destination node
@@ -94,9 +138,26 @@
    * Serialize and send a packet to the specified node and net device
    */
   static void SendPacket (Ptr<Packet> p, const Time &rxTime, uint32_t node, uint32_t dev);
+
+  /**
+   * \brief Return the communicator used to run ns-3.
+   *
+   * The communicator returned will be MPI_COMM_WORLD if Enable (int*
+   * pargc, char*** pargv) is used to enable or the user specified
+   * communicator if Enable (MPI_Comm communicator) is used.
+   *
+   * \return The MPI Communicator.
+   */
+  static MPI_Comm GetCommunicator();
+
 private:
 
   /**
+   * Common enable logic.
+   */
+  static void SetParallelSimulatorImpl (void);
+
+  /**
    * Static instance of the instantiated parallel controller.
    */
   static ParallelCommunicationInterface* g_parallelCommunicationInterface;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/mpi-receiver.cc ns-3.33/src/mpi/model/mpi-receiver.cc
--- ns-3.32/src/mpi/model/mpi-receiver.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/mpi-receiver.cc	2021-01-09 10:19:22.000000000 -0800
@@ -16,6 +16,13 @@
  * Author: George Riley <riley@ece.gatech.edu>
  */
 
+/**
+ * \file
+ * \ingroup mpi
+ * ns3::MpiReciver implementation,
+ * provides an interface to aggregate to MPI-compatible NetDevices.
+ */
+
 #include "mpi-receiver.h"
 
 namespace ns3 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/model/mpi-receiver.h ns-3.33/src/mpi/model/mpi-receiver.h
--- ns-3.32/src/mpi/model/mpi-receiver.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/model/mpi-receiver.h	2021-01-09 10:19:22.000000000 -0800
@@ -16,7 +16,12 @@
  * Author: George Riley <riley@ece.gatech.edu>
  */
 
-// Provides an interface to aggregate to MPI-compatible NetDevices
+/**
+ * \file
+ * \ingroup mpi
+ * ns3::MpiReciver declaration,
+ * provides an interface to aggregate to MPI-compatible NetDevices.
+ */
 
 #ifndef NS3_MPI_RECEIVER_H
 #define NS3_MPI_RECEIVER_H
@@ -42,6 +47,10 @@
 class MpiReceiver : public Object
 {
 public:
+  /**
+   *  Register this type.
+   *  \return The object TypeId.
+   */
   static TypeId GetTypeId (void);
   virtual ~MpiReceiver ();
 
@@ -58,6 +67,7 @@
 private:
   virtual void DoDispose (void);
 
+  /** Callback to send received packets to. */
   Callback<void, Ptr<Packet> > m_rxCallback;
 };
 
